program NkHotKey;

{$IMPORTEDDATA OFF}

uses Windows, NLib, NSys, Main, NotifyIcon;

{$R *.RES}

procedure Error(const E: TObject);
begin
  MsgBox(FormatException(Exception(ExceptObject)));
  ExitCode := 1;
end;

const
  MutexName: PWideChar = AppName + 'Mutex';
var
  msg: TMsg;
  r: Integer;
begin
  try
    if CreateMutexW(nil, True, MutexName) = 0 then
      raise EOSError.Create;
    if GetLastError = ERROR_ALREADY_EXISTS then
    begin
      MsgBox('Already run.');
      Exit;
    end;
  except
    Error(ExceptObject);
    ExitCode := 1;
    Exit;
  end;

  try
    ChDir(DirName(ProgPath));

    ProfDir := GetEnv('NKTOOLSPROF');
    if ProfDir = '' then
      ProfDir := DirName(ProgPath)
    else
      ProfDir := JoinPath([ProfDir, 'nkhotkey']);

    KeymapFilePath := JoinPath([ProfDir, 'keymap']);

    MainWnd := MakeWindow;
    try
      AddNotifyIcon;
      try
        UpdateHotKeys;
        try
          while True do
          begin
            r := Integer(GetMessageW(msg, 0, 0, 0));
            if r = -1 then
              raise EOSError.Create;
            if r = 0 then
              Break;
            DispatchMessageW(msg);
          end;
        finally
          ClearHotKeys;
        end;
      finally
        DeleteNotifyIcon;
      end;
    finally
      DestroyWindow(MainWnd);
    end;
  except
    Error(ExceptObject);
  end;
end.
