unit NExpand;

{$IMPORTEDDATA OFF}

interface

uses NTypes, NLib;

type
  TGetValueFunc = function (const Name: WideString): TWideStringArray;

function Expand(const Args: array of WideString; GetValue: TGetValueFunc):
    TWideStringArray;

implementation

procedure ExtendArray(var A: TWideStringArray; const B: array of WideString);
var
  i, len: Integer;
begin
  if Length(B) = 0 then
    Exit;
  len := Length(A);
  SetLength(A, len + Length(B));
  for i := 0 to High(B) do
    A[len+i] := B[i];
end;

procedure Add(var A: TWideStringArray; const B: array of WideString);
var
  i: Integer;
  s: string;
begin
  if Length(B) = 0 then
    Exit;
  if Length(A) = 0 then
    ExtendArray(A, B)
  else if Length(A) = Length(B) then
    for i := 0 to High(A) do
       A[i] := A[i] + B[i]
  else if Length(A) = 1 then begin
    s := A[0];
    SetLength(A, Length(B));
    for i := 0 to High(B) do
       A[i] := s + B[i];
  end else if Length(B) = 1 then
    for i := 0 to High(A) do
       A[i] := A[i] + B[0]
  else
    raise EValueError.Create;
end;

function Expand1(const S: WideString; GetValue: TGetValueFunc): TWideStringArray;
const
  delims = [
    WideChar($00)..WideChar($1f), WideChar(' ')..WideChar('!'),
    WideChar('#')..WideChar(')'), WideChar('+')..WideChar('/'),
    WideChar(':')..WideChar('@'), WideChar('[')..WideChar('\'),
    WideChar('{')..WideChar($7f)
  ];
var
  sym: WideString;
  i: Integer;
  q, qq: Boolean;
  m: WideChar;
begin
  Result := nil;
  q := False;
  qq := False;
  sym := '';
  i := 1;
  while i <= Length(S) do begin
    m := S[i];
    Inc(i);

    if qq then begin
      sym := sym + m;
      qq := False;
      Continue;
    end;

    if q then begin
      if m = '"' then
      begin
        if sym <> '' then
        begin
          Add(Result, GetValue(sym));
          sym := '';
        end;
        q := False
      end else
        sym := sym + m;
    end else if m = '"' then begin
      if S[i] = '"' then begin
        qq := True;
        Continue;
      end;
      q := True
    end else if m in delims then begin
      if sym <> '' then
        Add(Result, GetValue(sym));
      sym := m;
    end else
      sym := sym + m;
  end;
  if sym <> '' then
    Add(Result, GetValue(sym));
end;

function Expand(const Args: array of WideString; GetValue: TGetValueFunc):
    TWideStringArray;
var
  i: Integer;
begin
  Result := nil;
  for i := 0 to High(Args) do
    ExtendArray(Result, Expand1(Args[i], GetValue));
end;

end.
